#
# Implements slightly more efficient way of reading the Stats & Rates arrays
# Makes a single read call for the array not one per item
# N.B. The Stats & Rates tcl "arrays" are now lists not arrays
# Not even sure they're needed at all
#
# Implements server choice - merge or one of the asps
#

set RDOUTserverList [inform sys inquire RDOUTserverList]
set RDOUTserver [first $RDOUTserverList]

set MergeRegPrefix "NetVar.DACQ"

set StatsNetVarName "DACQ_Stats"
set RatesNetVarName "DACQ_Rates"
set StatsRegName "StatsArray"
set RatesRegName "RatesArray"
set AttList "-tint -prw -ayes -i0 -fd"


proc custom_pre_make {} { global NUM; make-registers $NUM; }

proc custom_clear {} { }

proc find_servers {} {
   global RDOUTserverList RDOUTserver

   set RDOUTserverList [inform sys inquire RDOUTserverList]
   set RDOUTserver [first $RDOUTserverList]
}

proc make-registers {num} {
   global RegisterServer RDOUTserverList EGreport
   global AttList
   global StatsNetVarName RatesNetVarName
   global StatsRegName RatesRegName
   global MergeRegPrefix

   find_servers

   set RegisterServer [first $RDOUTserverList]

   set EGr $EGreport
   set EGreport -1

   set RegPrefix $MergeRegPrefix
   set NetVarPrefix ""

   set attlist $AttList
   lappend attlist "-n$NetVarPrefix$StatsNetVarName"
   lappend attlist "-l$num"
   define-register generic $RegPrefix.$StatsRegName "$attlist"

   set attlist $AttList
   lappend attlist "-n$NetVarPrefix$RatesNetVarName"
   lappend attlist "-l$num"
   define-register generic $RegPrefix.$RatesRegName "$attlist"
 
   set EGreport $EGr
}

proc read-Stats {} {
  global RDOUTserver NUM
  global MergeRegPrefix
  global StatsRegName RegisterServer

  set RegisterServer $RDOUTserver
  set RegPrefix $MergeRegPrefix

  set reg $RegPrefix.$StatsRegName
  write-attributes $reg "-l $NUM"
  set reg /$RegisterServer/$reg
  return [EG "register :name '$reg' ?value"]
}

proc read-Rates {} {
  global RDOUTserver NUM
  global MergeRegPrefix
  global RatesRegName RegisterServer

  set RegisterServer $RDOUTserver
  set RegPrefix $MergeRegPrefix

  set reg $RegPrefix.$RatesRegName
  write-attributes $reg "-l $NUM"
  set reg /$RegisterServer/$reg
  return [EG "register :name '$reg' ?value"]
}

proc click-redisplay {} {
   global RDOUTserver NUM ITEM Stats Rates
   global EGreport

   set-footer "Updating..."
   set EGreport -1
   set-busy

   set Stats [read-Stats]
   for {set i 0} {$i < $NUM} {incr i} {
       if {[info exists ITEM($i)]} then {
	   :modify STAT$i :value [lindex $Stats $i]
       }
   }

   set Rates [read-Rates]
   for {set i 0} {$i < $NUM} {incr i} {
       if {[info exists ITEM($i)]} then {
	   :modify RATE$i :value [lindex $Rates $i]
       }
   }

   custom_redisplay

   clear-busy
   set EGreport 0
   set-footer "Counts Updated [date]"
}
